/***************************************************
 * 작성자 : 이종우
 * 작성일 : 2014.09.01
 * 수정일 : 2014.10.30
 * 설 명 : 최근 항목 page 에 대한 전반적인 기능 구현
***************************************************/

var KEY_ENTER;

var MAX_BYTE			= 200;
var MAX_RECENTLY_ITEM 	= 10;

$(document).ready(function() {	
	// 일반 화면에서 항목 선택 시
	$('.lnb ul li a').on('click', function(){
		var itemLink = $(this).attr("href");
		setRecentlyItem(itemLink);	
	});
	
	// add, jongwoo_lee, 20141030
	// setting_key 쪽 변경으로 인하여 추가
	// setting 에서 항목 선택 시
	$('.lnb ul li .sub-menu li a').on('click', function() {
		var itemLink = $(this).attr("href");
		setRecentlyItem(itemLink);
		window.localStorage.setItem("backNumber", Number(backNumber) +1 );
	});
	
	// 전체보기, index page 에서 항목 선택 시
	$('.list ul li a').on('click', function(){
		//var recentlyItem = $(this).text();
		var itemLink = $(this).attr("onclick");
		var linkArray = itemLink.split(",");
		var linkString = linkArray[2];
		var itemLinkArray = linkString.split("'");
		window.localStorage.setItem("backNumber", Number(backNumber) +1 );
		setRecentlyItem(itemLinkArray[1]);

	});
		
	// 최근 항목 페이지에서 항목 선택 시
	$(document).on('click', '.list-2 ul li a', function(){
		// get link
		var itemLink = $(this).attr("href");
		var linkArray = itemLink.split(",");
		var linkString = linkArray[2];
		var itemLinkArray = linkString.split("'");
		window.localStorage.setItem("backNumber", Number(backNumber) +1 );
		setRecentlyItem(itemLinkArray[1]);
	});
});

// modified, item and link double check -> link check, jongwoo_lee 20140919
function setRecentlyItem(itemLink) {
//	console.log(" setRecently start ... / link : " + itemLink);
	
	// local storage 에 저장된 항목들의 link
	var savedRecentlyItemsLink = [];
	// local storage 의 길이
	var localStorageLength = 0;
	
	// 존재 하는 항목의 index
	var existIndex = -1;
	
	// local storage 사용 가능한지 검사
	if(window.localStorage) {	
		for(var i=0; i<MAX_RECENTLY_ITEM; i++) {
			if(String("recentlyItemLink"+i)) {
				// 항목 링크 추출
				savedRecentlyItemsLink[i] = window.localStorage.getItem(String("recentlyItemLink"+i));

				// 항목 링크 확인
				//console.log("savedRecentlyItemsLink["+i+"] : " + savedRecentlyItemsLink[i]);
				
				// get local storage length
				if(savedRecentlyItemsLink[i] != null) {
					localStorageLength++;
				}
				
				// get exist item index
				if(savedRecentlyItemsLink[i] == itemLink) {
					existIndex = i;
					//console.log("existIndex : " + existIndex);
				}
			}	
		}
		
		//console.log("load local storage data... ( " + localStorageLength + " )");
		
		// 항목이 존재할 경우
		if(existIndex >= 0) {
			// 하나씩 뒤로 pull
			for(var j=existIndex; j>0; j--) {
				savedRecentlyItemsLink[j] = savedRecentlyItemsLink[j-1];
			}
		}
		// 항목이 존재하지 않을 경우
		else {
			// 하나씩 뒤로 pull
			for(var j=localStorageLength; j>=0; j--) {
				savedRecentlyItemsLink[j] = savedRecentlyItemsLink[j-1];
			}
		}
		
		//console.log("finish data pull..");
		
		// 최근 항목 저장
		savedRecentlyItemsLink[0] = itemLink;
		if(localStorageLength < MAX_RECENTLY_ITEM && existIndex < 0) {
			localStorageLength++;
		}
		
		//console.log("save recently item.. ("+localStorageLength+")");

		// save items
		for(var k=0; k<localStorageLength; k++) {
			window.localStorage.setItem(String("recentlyItemLink"+k), savedRecentlyItemsLink[k]);
			//console.log("savedItem["+k+"] : " + window.localStorage.getItem(String("recentlyItem"+k)));
			//console.log("savedItemLink["+k+"] : " + window.localStorage.getItem(String("recentlyItemLink"+k)));
		}
		
		//console.log("set recently item success!");
	}
	else {
		//console.log("local storage non-exist T.T");
	}
}

function getRecentlyItem() {
//	console.log("get recently item start....");

	// local storage 에 저장된 항목의 링크들 저장할 변수
	var savedRecentlyItemsLink = [];
	// local storage 의 길이
	var localStorageLength = 0;
	
	// local storage 사용 가능한지 검사
	if(window.localStorage) {	
		for(var i=0; i<MAX_RECENTLY_ITEM; i++) {
			if(String("recentlyItemLink"+i)) {
				// 항목의 링크 추출
				savedRecentlyItemsLink[i] = window.localStorage.getItem(String("recentlyItemLink"+i));
				
				// 항목의 링크 확인
				//console.log("savedRecentlyItemsLink["+i+"] : " + savedRecentlyItemsLink[i]);
				
				// get local storage length
				if(savedRecentlyItemsLink[i] != null) {
					localStorageLength++;
				}
			}	
		}
		
//		console.log("get recently items succ..");
		
		
		// 항목 확인 용	
//		for(var l=0; l<localStorageLength; l++) {
//			console.log("saved recentlyItemsLink["+l+"] : " 
//					+ window.localStorage.getItem(String("recentlyItemLink"+l)));
//		}
//		
//		console.log("local storage length : " + localStorageLength);

		// 항목이 있을 시
		if(localStorageLength > 0) {
			// ----------------------  화면에 출력 ----------------------
			var addTag = $(".list-2 ul");
			var savedItemIndex = 0;
			var itemTag = "";
			for(savedItemIndex=0; savedItemIndex<localStorageLength; savedItemIndex++) {
				$.each(window.param, function(index, indexerInfo) {
					if(indexerInfo.link == savedRecentlyItemsLink[savedItemIndex]) {
						// 링크 추출
						var linkArray = indexerInfo.link.split('/');
						//console.log("indexer link : " + indexerInfo.link + "\r\nlinkArray : " + linkArray);
						var subject = linkArray[4];
						
						var status = -1;
//						console.log("4번째 : " + linkArray[4]);
						if(linkArray[4].indexOf("_") > 0) {
							status = 0;
						}
						else {
							status = 1;
						}
						
						// add, jongwoo_lee, 20141029
						// indexer 수정으로 인하여 화면에 출력되는 summary 부분 처리 
						var indexerSummary = indexerInfo.summary;
//						if(checkByte(indexerInfo.search_body)) { indexerSummary += " ..."; }
						if(checkByte(indexerSummary)) { indexerSummary += " ..."; }
//						console.log("subject : " + subject + " / status : " + status + " / middle_path : " + linkArray[4]);
						var parameter = status + ", '" + subject + "', '" + indexerInfo.link + "'" + ", 'recently'";
						itemTag = 
								"<li>" +
									"<a href=\"javascript:detailPageProcess("+parameter+");\">" + 
										"<h4 class='contents-title'>" + indexerInfo.navi + " <em>" + indexerInfo.title + "</em></h4>" +
//										"<p class='desc'>" + indexerInfo.summary + " ..." + "</p>" +
										"<p class='desc'>" + indexerSummary + "</p>" +
									"</a>" + 
								"</li>";
						addTag.append(itemTag); 
					}
					
					itemTag = "";
				});
			}
		}
		// 항목 없을 시
		else {
//			$(".list-title").text("There is no recently viewed page.");
		}
		
//		console.log("record recently item information(html tag) success!");
	}
	else {
//		console.log("local storage non-exist T.T");
	}
}

function checkByte(str) { 
	var bRet = false;

	var size = 0;
	var charCode;
	var chr = null;

	for(var i=0; i<str.length; i++) { 
		chr = str.charAt(i);
		charCode = chr.charCodeAt(0);
		
		if(charCode <= 0x00007F)		{ size += 1; }
		else if(charCode <= 0x0007FF) 	{ size += 2; }
		else if(charCode <= 0x00FFFF) 	{ size += 3; }
		else							{ size += 4; }
		
		if(size >= MAX_BYTE) {
			bRet = true;
			break;
		}
	}
	
	return bRet;
}

// 텍스트에서 태그 제거
function strip_tags (input, allowed) {
	// making sure the allowed arg is a string containing only tags in lowercase (<a><b><c>)
    allowed = (((allowed || "") + "").toLowerCase().match(/<[a-z][a-z0-9]*>/g) || []).join(''); 
    var tags = /<\/?([a-z][a-z0-9]*)\b[^>]*>/gi,
        commentsAndPhpTags = /<!--[\s\S]*?-->|<\?(?:php)?[\s\S]*?\?>/gi;
    return input.replace(commentsAndPhpTags, '').replace(tags, function ($0, $1) {  
    	return allowed.indexOf('<' + $1.toLowerCase() + '>') > -1 ? $0 : '';
    });
}
